lens-5.2.3: Lenses, Folds and Traversals

Copyright | (C) 2012-2016 Edward Kmett
License | BSD-style (see the file LICENSE)
Maintainer | Edward Kmett <ekmett@gmail.com>
Stability | experimental
Portability | non-portable
Safe Haskell | Trustworthy
Language | Haskell2010

Control.Lens.Internal.Iso

Description

Synopsis

- data Exchange a b s t = Exchange (s -> a) (b -> t)
- class Reversing t where
  - reversing :: t -> t

# Documentation

data Exchange a b s t #

This is used internally by the `Iso` code to provide efficient access to the two functions that make up an isomorphism.

Constructors

Exchange (s -> a) (b -> t) |

#### Instances

Instances details

Profunctor (Exchange a b) # |

Instance details

Defined in Control.Lens.Internal.Iso

Methods

dimap :: (a0 -> b0) -> (c -> d) -> Exchange a b b0 c -> Exchange a b a0 d #

lmap :: (a0 -> b0) -> Exchange a b b0 c -> Exchange a b a0 c #

rmap :: (b0 -> c) -> Exchange a b a0 b0 -> Exchange a b a0 c #

(#.) :: forall a0 b0 c q. Coercible c b0 => q b0 c -> Exchange a b a0 b0 -> Exchange a b a0 c #

(.#) :: forall a0 b0 c q. Coercible b0 a0 => Exchange a b b0 c -> q a0 b0 -> Exchange a b a0 c #

Functor (Exchange a b s) # |
Instance details Defined in Control.Lens.Internal.Iso Methods fmap :: (a0 -> b0) -> Exchange a b s a0 -> Exchange a b s b0 # (<$) :: a0 -> Exchange a b s b0 -> Exchange a b s a0 #

class Reversing t where #

This class provides a generalized notion of list reversal extended to other containers.

Methods

reversing :: t -> t #

#### Instances

Instances details

Reversing ByteString # |
Instance details Defined in Control.Lens.Internal.Iso Methods reversing :: ByteString -> ByteString #
Reversing ByteString # |
Instance details Defined in Control.Lens.Internal.Iso Methods reversing :: ByteString -> ByteString #
Reversing Text # |
Instance details Defined in Control.Lens.Internal.Iso Methods reversing :: Text -> Text #
Reversing Text # |
Instance details Defined in Control.Lens.Internal.Iso Methods reversing :: Text -> Text #
Reversing (NonEmpty a) # |
Instance details Defined in Control.Lens.Internal.Iso Methods reversing :: NonEmpty a -> NonEmpty a #
Reversing (Seq a) # |
Instance details Defined in Control.Lens.Internal.Iso Methods reversing :: Seq a -> Seq a #
Reversing (Deque a) # |
Instance details Defined in Control.Lens.Internal.Deque Methods reversing :: Deque a -> Deque a #
Reversing (Vector a) # |
Instance details Defined in Control.Lens.Internal.Iso Methods reversing :: Vector a -> Vector a #
Prim a => Reversing (Vector a) # |
Instance details Defined in Control.Lens.Internal.Iso Methods reversing :: Vector a -> Vector a #
Storable a => Reversing (Vector a) # |
Instance details Defined in Control.Lens.Internal.Iso Methods reversing :: Vector a -> Vector a #
Unbox a => Reversing (Vector a) # |
Instance details Defined in Control.Lens.Internal.Iso Methods reversing :: Vector a -> Vector a #
Reversing [a] # |
Instance details Defined in Control.Lens.Internal.Iso Methods reversing :: [a] -> [a] #